const { v4: uuidv4 } = require('uuid');

function getDefaults() {
    return {
        raw: {
            json: true
        },
        method: 'POST',
        headers: {
            sourceSystem: 'DigitalWallet',
            targetSystem: 'ESB',
            priority: 0,
            userLanguage: 'BG'
        }
    };
}

function getDynamicHeaders($meta = {}) {
    const now = new Date();
    const transactionTimeStamp = now.toISOString();
    const transactionDateStamp = new Date(now.getTime() + (now.getTimezoneOffset() * 60 * 1000)).toISOString().split('T')[0];

    const headers = {
        transactionId: uuidv4(),
        transactionUser: $meta?.auth?.actorId || 'Wallet',
        transactionDateStamp,
        transactionTimeStamp,
        CustomerIDResourceOwner: $meta.CustomerIDResourceOwner || $meta?.auth?.handle || 'Unauthenticated'
    };

    return headers;
}

module.exports = {
    getDefaults,
    getDynamicHeaders
};
